org.cpsolver.coursett.preference

## Class PreferenceCombination

- java.lang.Object
- - org.cpsolver.coursett.preference.PreferenceCombination

- Direct Known Subclasses:
    AveragePreferenceCombination, MinMaxPreferenceCombination, SumPreferenceCombination

      public abstract class PreferenceCombination
      extends Object

  Preference combination.
  A preference can be:
  - R .. required
  - P .. prohibited
  - number .. soft preference (smaller value is better)
  Version:
    CourseTT 1.3 (University Course Timetabling)
    Copyright (C) 2006 - 2014 Tomáš Müller
    muller@unitime.org
    http://muller.unitime.org
    This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public License along with this library; if not see http://www.gnu.org/licenses/.
  Author:
    Tomáš Müller

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `PreferenceCombination()`
    `PreferenceCombination(PreferenceCombination c)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addPreferenceInt(int intPref)` Returns combined preference from the given preferences
    `void` | `addPreferenceProlog(String prologPref)` Add preference a preference
    `abstract PreferenceCombination` | `clonePreferenceCombination()`
    `static PreferenceCombination` | `getDefault()`
    `abstract int` | `getPreferenceInt()`
    `String` | `getPreferenceProlog()`
    `boolean` | `isProhibited()`
    `boolean` | `isRequired()`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### PreferenceCombination

          public PreferenceCombination()

    - #### PreferenceCombination

          public PreferenceCombination(PreferenceCombination c)

  - ### Method Detail

    - #### addPreferenceProlog

          public void addPreferenceProlog(String prologPref)

      Add preference a preference
      Parameters:
        `prologPref` - prolog preference (R for required, P for prohibited, -2 strongly preferred, ... 2 strongly discouraged)

    - #### addPreferenceInt

          public void addPreferenceInt(int intPref)

      Returns combined preference from the given preferences
      Parameters:
        `intPref` - preference

    - #### isRequired

          public boolean isRequired()

    - #### isProhibited

          public boolean isProhibited()

    - #### clonePreferenceCombination

          public abstract PreferenceCombination clonePreferenceCombination()

    - #### getPreferenceInt

          public abstract int getPreferenceInt()

    - #### getPreferenceProlog

          public String getPreferenceProlog()

    - #### getDefault

          public static PreferenceCombination getDefault()